#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include "gpdef.h"
#include "gpstdlib.h"
#include "gpgraphic.h"
#include "gpmain.h"
#include "gpfont.h"

#include "MathFunc.h"

/************************
*
* ZoomPicture
*
* Display a zoomed picure.
*
* Note: i = zoom factor
* 
*************************/

void ZoomPicture(GPDRAWSURFACE* gpDraw, int ZoomFactor, unsigned char Picture[], int Picture_x, int Picture_y, char transparency)
{
	int j, k, x, y;
	int startx, starty, sizex, sizey, offsetx, offsety;

	unsigned char *ZoomedPic;
	ZoomedPic = gp_mem_func.malloc(Picture_x*ZoomFactor*Picture_y*ZoomFactor*sizeof(unsigned char));

	for (x=0; x<Picture_x; x++)
	{
		for (y=0; y<Picture_y; y++)
		{
			for (j=0; j<ZoomFactor; j++)
			{
				for (k=0; k<ZoomFactor; k++)
				{
					ZoomedPic[(x*ZoomFactor+j)*Picture_y*ZoomFactor+y*ZoomFactor+k] = Picture[x*Picture_y+y];
				}
			}
		}

	}

	startx = max(0, 320/2 - (Picture_x*ZoomFactor)/2);
	starty = max(0, 240/2 - (Picture_y*ZoomFactor)/2);
	sizex = max(320, Picture_x*ZoomFactor);
	sizey = max(240, Picture_y*ZoomFactor);
	offsetx = max(0, (Picture_x*ZoomFactor)/2 - (320/2));
	offsety = max(0, (Picture_y*ZoomFactor)/2 - 240/2);

	GpTransBlt(NULL, 
	         gpDraw,
			startx, starty,
			sizex, sizey,
			(unsigned char*)ZoomedPic,
			offsetx, offsety,
			Picture_x*ZoomFactor, Picture_y*ZoomFactor,
			transparency);

	gp_mem_func.free((void*)ZoomedPic);
	ZoomedPic = NULL;
}

// There are still some optimization to do. Eg: not calculate the whole ZoomedPicture but just the viewable area...