#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include "gpdef.h"
#include "gpstdlib.h"
#include "gpgraphic.h"
#include "gpmain.h"
#include "gpfont.h"


/****************************************
*
* IntroScreen
*
* Display a introduction screen with text
* that fades out.
*
* 
*****************************************/
void IntroScreen(GPDRAWSURFACE* gpDraw)
{
	unsigned int i;

	// Surface fill color in black
	GpRectFill(NULL, gpDraw, 0, 0, gpDraw->buf_w, gpDraw->buf_h, 0x00);

	GpTextOut(NULL, gpDraw, 100, 100, (char*)"OMSK Presents", 0xfe);

	// Wait a few milliseconds
	GpThreadSleep(500/2); // 500 milliseconds delay

	for (i = 0; i < 30; i++)
	{
		GpLcdFade(1, NULL);

		// Wait a few milliseconds
		GpThreadSleep(50/2); // 50 milliseconds delay
	}

	// Surface fill color in white
	GpRectFill(NULL, gpDraw, 0, 0, gpDraw->buf_w, gpDraw->buf_h, 0x00);

	GpLcdNoFade(NULL);
}
